OGRE: Ogre::SceneNode Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::SceneNode Class Reference
Core » Scene

Class representing a node in the scene graph. More...

`#include <OgreSceneNode.h>`

Inheritance diagram for Ogre::SceneNode:
[legend]

## Public Types
typedef ConstVectorIterator< ObjectMap > | ConstObjectIterator
typedef VectorIterator< ObjectMap > | ObjectIterator
typedef std::vector< MovableObject * > | ObjectMap
Public Types inherited from Ogre::Node
typedef VectorIterator< ChildNodeMap > | ChildNodeIterator
typedef std::vector< Node * > | ChildNodeMap
typedef ConstVectorIterator< ChildNodeMap > | ConstChildNodeIterator
enum | TransformSpace { TS_LOCAL , TS_PARENT , TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...

## Public Member Functions
| SceneNode (SceneManager *creator, const String &name="")
| Constructor, only to be called by the creator SceneManager.
| ~SceneNode ()
void | _autoTrack (void)
| Internal method used by OGRE to update auto-tracking cameras.
void | _findVisibleObjects (Camera *cam, RenderQueue *queue, VisibleObjectsBoundsInfo *visibleBounds, bool includeChildren=true, bool displayNodes=false, bool onlyShadowCasters=false)
| Internal method which locates any visible objects attached to this node and adds them to the passed in queue.
const AxisAlignedBox & | _getWorldAABB (void) const
| Gets the axis-aligned bounding box of this node (and hence all subnodes).
void | _notifyRootNode (void)
| Notifies this SceneNode that it is the root scene node.
void | _update (bool updateChildren, bool parentHasChanged) override
| Internal method to update the Node.
virtual void | _updateBounds (void)
| Tells the SceneNode to update the world bound info it stores.
virtual void | attachObject (MovableObject *obj)
| Adds an instance of a scene object to this node.
virtual SceneNode * | createChildSceneNode (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named SceneNode as a child of this node.
virtual SceneNode * | createChildSceneNode (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new SceneNode as a child of this node.
void | destroyAllChildrenAndObjects ()
| Destroys everything attatched to or decended from this node.
void | destroyAllObjects (void)
| Detaches and destroys all objects attached to this node.
void | destroyChildAndObjects (const String &name)
| Removes and destroys the child and all movable objects attached to the child, and does the same to any children of that child node.
void | destroyChildAndObjects (SceneNode *child)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyChildAndObjects (unsigned short index)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | detachAllObjects (void)
| Detaches all objects attached to this node.
virtual MovableObject * | detachObject (const String &name)
| Detaches the named object from this node and returns a pointer to it.
virtual void | detachObject (MovableObject *obj)
| Detaches an object by pointer.
virtual MovableObject * | detachObject (unsigned short index)
| Detaches the indexed object from this scene node.
void | findLights (LightList &destList, Real radius, uint32 lightMask=0xFFFFFFFF) const
| Allows retrieval of the nearest lights to the centre of this SceneNode.
void | flipVisibility (bool cascade=true) const
| Inverts the visibility of all objects attached to this node.
MovableObject * | getAttachedObject (const String &name) const
| Retrieves a pointer to an attached object by name.
MovableObject * | getAttachedObject (size_t index) const
| Retrieves a pointer to an attached object by index.
ObjectIterator | getAttachedObjectIterator (void)
ConstObjectIterator | getAttachedObjectIterator (void) const
const ObjectMap & | getAttachedObjects () const
| The MovableObjects attached to this node.
const Vector3 & | getAutoTrackLocalDirection (void) const
| Get the auto tracking local direction for this node, if it is auto tracking.
const Vector3 & | getAutoTrackOffset (void) const
| Get the auto tracking offset for this node, if the node is auto tracking.
SceneNode * | getAutoTrackTarget (void) const
| Get the auto tracking target for this node, if any.
SceneManager * | getCreator (void) const
| Gets the creator of this scene node.
SceneNode * | getParentSceneNode (void) const
| Gets the parent of this SceneNode.
bool | getShowBoundingBox () const
| This allows scene managers to determine if the node's bounding box should be added to the rendering queue.
bool | isInSceneGraph (void) const
| Determines whether this node is in the scene graph, i.e.
void | loadChildren (const String &filename)
| Load a scene from a file as children of this node.
void | lookAt (const Vector3 &targetPoint, TransformSpace relativeTo, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Points the local -Z direction of this node at a point in space.
size_t | numAttachedObjects (void) const
| Reports the number of objects attached to this node.
void | removeAndDestroyAllChildren (void)
| Removes and destroys all children of this node.
void | removeAndDestroyChild (const String &name)
| This method removes and destroys the named child and all of its children.
void | removeAndDestroyChild (SceneNode *child)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | removeAndDestroyChild (unsigned short index)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | saveChildren (const String &filename)
| Save the scene hierarchy starting at this node to file.
void | setAutoTracking (bool enabled, SceneNode *const target=0, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of another SceneNode.
void | setDebugDisplayEnabled (bool enabled, bool cascade=true) const
| Tells all objects attached to this node whether to display their debug information or not.
void | setDirection (const Vector3 &vec, TransformSpace relativeTo=TS_PARENT, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setDirection (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Sets the node's direction vector ie it's local -z.
void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the node whether to yaw around it's own local Y axis or a fixed axis of choice.
void | setVisible (bool visible, bool cascade=true) const
| Makes all objects attached to this node become visible / invisible.
void | showBoundingBox (bool bShow)
| Allows the showing of the node's bounding box.
void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL) override
| Rotate the node around the Y-axis.
Public Member Functions inherited from Ogre::Node
| Node (const String &name="")
| Constructor, should only be called by parent, not directly.
virtual | ~Node ()
const Quaternion & | _getDerivedOrientation (void) const
| Gets the orientation of the node as derived from all parents.
const Vector3 & | _getDerivedPosition (void) const
| Gets the position of the node as derived from all parents.
const Vector3 & | _getDerivedScale (void) const
| Gets the scaling factor of the node as derived from all parents.
const Affine3 & | _getFullTransform (void) const
| Gets the full transformation matrix for this node.
void | _setDerivedOrientation (const Quaternion &q)
| Sets the final world orientation of the node directly.
void | _setDerivedPosition (const Vector3 &pos)
| Sets the final world position of the node directly.
void | addChild (Node *child)
| Adds a (precreated) child scene node to this node.
void | cancelUpdate (Node *child)
| Called by children to notify their parent that they no longer need an update.
Vector3 | convertLocalToWorldDirection (const Vector3 &localDir, bool useScale)
| Gets the world direction of a point in the node local space useful for simple transforms that don't require a child node.
Quaternion | convertLocalToWorldOrientation (const Quaternion &localOrientation)
| Gets the world orientation of an orientation in the node local space useful for simple transforms that don't require a child node.
Vector3 | convertLocalToWorldPosition (const Vector3 &localPos)
| Gets the world position of a point in the node local space useful for simple transforms that don't require a child node.
Vector3 | convertWorldToLocalDirection (const Vector3 &worldDir, bool useScale)
| Gets the local direction, relative to this node, of the given world-space direction.
Quaternion | convertWorldToLocalOrientation (const Quaternion &worldOrientation)
| Gets the local orientation, relative to this node, of the given world-space orientation.
Vector3 | convertWorldToLocalPosition (const Vector3 &worldPos)
| Gets the local position, relative to this node, of the given world-space position.
virtual Node * | createChild (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named Node as a child of this node.
virtual Node * | createChild (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new Node as a child of this node.
Node * | getChild (const String &name) const
| Gets a pointer to a named child node.
Node * | getChild (unsigned short index) const
| Gets a pointer to a child node.
ChildNodeIterator | getChildIterator (void)
ConstChildNodeIterator | getChildIterator (void) const
const ChildNodeMap & | getChildren () const
| List of sub-nodes of this Node.
bool | getInheritOrientation (void) const
| Returns true if this node is affected by orientation applied to the parent node.
bool | getInheritScale (void) const
| Returns true if this node is affected by scaling factors applied to the parent node.
const Quaternion & | getInitialOrientation (void) const
| Gets the initial orientation of this node, see setInitialState for more info.
const Vector3 & | getInitialPosition (void) const
| Gets the initial position of this node, see setInitialState for more info.
const Vector3 & | getInitialScale (void) const
| Gets the initial position of this node, see setInitialState for more info.
Listener * | getListener (void) const
| Gets the current listener for this Node.
Matrix3 | getLocalAxes (void) const
| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.
const String & | getName (void) const
| Returns the name of the node.
const Quaternion & | getOrientation () const
| Returns a quaternion representing the nodes orientation.
Node * | getParent (void) const
| Gets this node's parent (NULL if this is the root).
const Vector3 & | getPosition (void) const
| Gets the position of the node relative to it's parent.
const Vector3 & | getScale (void) const
| Gets the scaling factor of this node.
Real | getSquaredViewDepth (const Camera *cam) const
| Helper function, get the squared view depth.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | needUpdate (bool forceParentUpdate=false)
| To be called in the event of transform changes to this node that require it's recalculation.
uint16 | numChildren (void) const
| Reports the number of child nodes under this one.
virtual void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the X-axis.
virtual void | removeAllChildren (void)
| Removes all child Nodes attached to this node.
virtual Node * | removeChild (const String &name)
| Drops the named child from this node.
virtual Node * | removeChild (Node *child)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual Node * | removeChild (unsigned short index)
| Drops the specified child from this node.
void | requestUpdate (Node *child, bool forceParentUpdate=false)
| Called by children to notify their parent that they need an update.
void | resetOrientation (void)
| Resets the nodes orientation (local axes as world axes, no rotation).
void | resetToInitialState (void)
| Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.
virtual void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Z-axis.
void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis using a Quarternion.
void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis.
void | scale (const Vector3 &scale)
| Scales the node, combining it's current scale with the passed in scaling factor.
void | scale (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setInheritOrientation (bool inherit)
| Tells the node whether it should inherit orientation from it's parent node.
void | setInheritScale (bool inherit)
| Tells the node whether it should inherit scaling factors from it's parent node.
void | setInitialState (void)
| Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.
void | setListener (Listener *listener)
| Sets a listener for this Node.
void | setOrientation (const Quaternion &q)
| Sets the orientation of this node via a quaternion.
void | setOrientation (Real w, Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setPosition (const Vector3 &pos)
| Sets the position of the node relative to it's parent.
void | setPosition (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this node.
void | setScale (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setUserAny (const Any &anything)
void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the Cartesian axes.
void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::Node
static void | processQueuedUpdates (void)
| Process queued 'needUpdate' calls.
static void | queueNeedUpdate (Node *n)
| Queue a 'needUpdate' call to a node safely.

## Detailed Description

Class representing a node in the scene graph.

A SceneNode is a type of Node which is used to organise objects in a scene. It has the same hierarchical transformation properties of the generic Node class, but also adds the ability to attach world objects to the node, and stores hierarchical bounding volumes of the nodes in the tree. Child nodes are contained within the bounds of the parent, and so on down the tree, allowing for fast culling.

## Member Typedef Documentation

## ◆ ObjectMap

typedef std::vector<MovableObject*> Ogre::SceneNode::ObjectMap

## ◆ ObjectIterator

typedef VectorIterator<ObjectMap> Ogre::SceneNode::ObjectIterator

## ◆ ConstObjectIterator

typedef ConstVectorIterator<ObjectMap> Ogre::SceneNode::ConstObjectIterator

## Constructor & Destructor Documentation

## ◆ SceneNode()

Ogre::SceneNode::SceneNode | ( | SceneManager * | creator,
|  | const String & | name = "" )

Constructor, only to be called by the creator SceneManager.

Creates a node with a specified name.

References SceneManager.

Referenced by Ogre::BspSceneNode::BspSceneNode(), Ogre::BspSceneNode::BspSceneNode(), Ogre::PCZSceneNode::createChildSceneNode(), Ogre::PCZSceneNode::createChildSceneNode(), createChildSceneNode(), createChildSceneNode(), destroyChildAndObjects(), getAutoTrackTarget(), getParentSceneNode(), removeAndDestroyChild(), and setAutoTracking().

## ◆ ~SceneNode()

Ogre::SceneNode::~SceneNode | ( |  | ) |

## Member Function Documentation

## ◆ attachObject()

virtual void Ogre::SceneNode::attachObject | ( | MovableObject * | obj | ) |
| virtual

Adds an instance of a scene object to this node.

Scene objects can include Entity objects, Camera objects, Light objects, ParticleSystem objects etc. Anything that subclasses from MovableObject.

## ◆ numAttachedObjects()

size_t Ogre::SceneNode::numAttachedObjects | ( | void |  | ) | const
| inline

Reports the number of objects attached to this node.

## ◆ getAttachedObject() [1/2]

MovableObject * Ogre::SceneNode::getAttachedObject | ( | size_t | index | ) | const
| inline

Retrieves a pointer to an attached object by index.

Note
  The index of an object may change as other objects are added / removed.

## ◆ getAttachedObject() [2/2]

MovableObject * Ogre::SceneNode::getAttachedObject | ( | const String & | name | ) | const

Retrieves a pointer to an attached object by name.

## ◆ detachObject() [1/3]

virtual MovableObject * Ogre::SceneNode::detachObject | ( | unsigned short | index | ) |
| virtual

Detaches the indexed object from this scene node.

Detaches by index, see the alternate version to detach by name. Object indexes may change as other objects are added / removed.

Reimplemented in Ogre::BspSceneNode.

## ◆ detachObject() [2/3]

virtual void Ogre::SceneNode::detachObject | ( | MovableObject * | obj | ) |
| virtual

Detaches an object by pointer.

## ◆ detachObject() [3/3]

virtual MovableObject * Ogre::SceneNode::detachObject | ( | const String & | name | ) |
| virtual

Detaches the named object from this node and returns a pointer to it.

Reimplemented in Ogre::BspSceneNode.

## ◆ detachAllObjects()

virtual void Ogre::SceneNode::detachAllObjects | ( | void |  | ) |
| virtual

Detaches all objects attached to this node.

Reimplemented in Ogre::BspSceneNode.

## ◆ destroyAllObjects()

void Ogre::SceneNode::destroyAllObjects | ( | void |  | ) |

Detaches and destroys all objects attached to this node.

Does not destroy objects attached to children of this node

## ◆ isInSceneGraph()

bool Ogre::SceneNode::isInSceneGraph | ( | void |  | ) | const
| inline

Determines whether this node is in the scene graph, i.e.

whether it's ultimate ancestor is the root scene node.

## ◆ _notifyRootNode()

void Ogre::SceneNode::_notifyRootNode | ( | void |  | ) |
| inline

Notifies this SceneNode that it is the root scene node.

Only SceneManager should call this!

## ◆ _update()

void Ogre::SceneNode::_update | ( | bool | updateChildren,
|  | bool | parentHasChanged )
| overridevirtual

Internal method to update the Node.

Note
  Updates this scene node and any relevant children to incorporate transforms etc. Don't call this yourself unless you are writing a SceneManager implementation.

Parameters

  updateChildren | If true, the update cascades down to all children. Specify false if you wish to update children separately, e.g. because of a more selective SceneManager implementation.
  parentHasChanged | This flag indicates that the parent transform has changed, so the child should retrieve the parent's transform and combine it with its own even if it hasn't changed itself.

Reimplemented from Ogre::Node.

## ◆ _updateBounds()

virtual void Ogre::SceneNode::_updateBounds | ( | void |  | ) |
| virtual

Tells the SceneNode to update the world bound info it stores.

## ◆ _findVisibleObjects()

void Ogre::SceneNode::_findVisibleObjects | ( | Camera * | cam,
|  | RenderQueue * | queue,
|  | VisibleObjectsBoundsInfo * | visibleBounds,
|  | bool | includeChildren = true,
|  | bool | displayNodes = false,
|  | bool | onlyShadowCasters = false )

Internal method which locates any visible objects attached to this node and adds them to the passed in queue.

Should only be called by a SceneManager implementation, and only after the _updat method has been called to ensure transforms and world bounds are up to date. SceneManager implementations can choose to let the search cascade automatically, or choose to prevent this and select nodes themselves based on some other criteria.

Parameters

  cam | The active camera
  queue | The SceneManager's rendering queue
  visibleBounds | bounding information created on the fly containing all visible objects by the camera
  includeChildren | If true, the call is cascaded down to all child nodes automatically.
  displayNodes | If true, the nodes themselves are rendered as a set of 3 axes as well as the objects being rendered. For debugging purposes.
  onlyShadowCasters |

## ◆ _getWorldAABB()

const AxisAlignedBox & Ogre::SceneNode::_getWorldAABB | ( | void |  | ) | const
| inline

Gets the axis-aligned bounding box of this node (and hence all subnodes).

Recommended only if you are extending a SceneManager, because the bounding box returned from this method is only up to date after the SceneManager has called _update.

## ◆ getAttachedObjectIterator() [1/2]

ObjectIterator Ogre::SceneNode::getAttachedObjectIterator | ( | void |  | ) |

Deprecated
  use getAttachedObjects()

## ◆ getAttachedObjectIterator() [2/2]

ConstObjectIterator Ogre::SceneNode::getAttachedObjectIterator | ( | void |  | ) | const

Deprecated
  use getAttachedObjects()

## ◆ getAttachedObjects()

const ObjectMap & Ogre::SceneNode::getAttachedObjects | ( |  | ) | const
| inline

The MovableObjects attached to this node.

This is a much faster way to go through all the objects attached to the node than using getAttachedObject.

## ◆ getCreator()

SceneManager * Ogre::SceneNode::getCreator | ( | void |  | ) | const
| inline

Gets the creator of this scene node.

This method returns the SceneManager which created this node. This can be useful for destroying this node.

References SceneManager.

## ◆ removeAndDestroyChild() [1/3]

void Ogre::SceneNode::removeAndDestroyChild | ( | const String & | name | ) |

This method removes and destroys the named child and all of its children.

Unlike removeChild, which removes a single named child from this node but does not destroy it, this method destroys the child and all of it's children.

  Use this if you wish to recursively destroy a node as well as detaching it from it's parent. Note that any objects attached to the nodes will be detached but will not themselves be destroyed.

## ◆ removeAndDestroyChild() [2/3]

void Ogre::SceneNode::removeAndDestroyChild | ( | unsigned short | index | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ removeAndDestroyChild() [3/3]

void Ogre::SceneNode::removeAndDestroyChild | ( | SceneNode * | child | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References SceneNode().

## ◆ removeAndDestroyAllChildren()

void Ogre::SceneNode::removeAndDestroyAllChildren | ( | void |  | ) |

Removes and destroys all children of this node.

Use this to destroy all child nodes of this node and remove them from the scene graph. Note that all objects attached to this node will be detached but will not be destroyed.

## ◆ destroyChildAndObjects() [1/3]

void Ogre::SceneNode::destroyChildAndObjects | ( | const String & | name | ) |

Removes and destroys the child and all movable objects attached to the child, and does the same to any children of that child node.

Does not destroy animation, textures, meshes associated with those movable objects

## ◆ destroyChildAndObjects() [2/3]

void Ogre::SceneNode::destroyChildAndObjects | ( | unsigned short | index | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ destroyChildAndObjects() [3/3]

void Ogre::SceneNode::destroyChildAndObjects | ( | SceneNode * | child | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References SceneNode().

## ◆ destroyAllChildrenAndObjects()

void Ogre::SceneNode::destroyAllChildrenAndObjects | ( |  | ) |

Destroys everything attatched to or decended from this node.

  Detaches and destroys all objects attached to this node or its children. Removes and destroys all the children of this node

  Use this method to complete destroy a node, for example, if you want to recreate its render tree from scratch.

  Does not destroy animations, textures, meshes associated with those movable objects Does not destroy the node itself

## ◆ loadChildren()

void Ogre::SceneNode::loadChildren | ( | const String & | filename | ) |

Load a scene from a file as children of this node.

The file and any referenced resources will be searched in ResourceGroupManager::getWorldResourceGroupName Depending on the type of SceneManager you can load different scene file-formats.

Parameters

  filename | source file containing the scene structure

## ◆ saveChildren()

void Ogre::SceneNode::saveChildren | ( | const String & | filename | ) |

Save the scene hierarchy starting at this node to file.

Parameters

  filename | destination file

## ◆ showBoundingBox()

void Ogre::SceneNode::showBoundingBox | ( | bool | bShow | ) |
| inline

Allows the showing of the node's bounding box.

Use this to show or hide the bounding box of the node.

## ◆ getShowBoundingBox()

bool Ogre::SceneNode::getShowBoundingBox | ( |  | ) | const
| inline

This allows scene managers to determine if the node's bounding box should be added to the rendering queue.

Scene Managers that implement their own _findVisibleObjects will have to check this flag and then use _addBoundingBoxToQueue to add the bounding box wireframe.

## ◆ createChildSceneNode() [1/2]

virtual SceneNode * Ogre::SceneNode::createChildSceneNode | ( | const Vector3 & | translate = Vector3::ZERO,
|  | const Quaternion & | rotate = Quaternion::IDENTITY )
| virtual

Creates an unnamed new SceneNode as a child of this node.

Parameters

  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

Reimplemented in Ogre::PCZSceneNode.

References SceneNode(), Ogre::Quaternion::IDENTITY, Ogre::Node::rotate(), and Ogre::Node::translate().

## ◆ createChildSceneNode() [2/2]

virtual SceneNode * Ogre::SceneNode::createChildSceneNode | ( | const String & | name,
|  | const Vector3 & | translate = Vector3::ZERO,
|  | const Quaternion & | rotate = Quaternion::IDENTITY )
| virtual

Creates a new named SceneNode as a child of this node.

This creates a child node with a given name, which allows you to look the node up from the parent which holds this collection of nodes.

Parameters

  name | name of the node
  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

Reimplemented in Ogre::PCZSceneNode.

References SceneNode(), Ogre::Quaternion::IDENTITY, Ogre::Node::rotate(), and Ogre::Node::translate().

## ◆ findLights()

void Ogre::SceneNode::findLights | ( | LightList & | destList,
|  | Real | radius,
|  | uint32 | lightMask = 0xFFFFFFFF ) const

Allows retrieval of the nearest lights to the centre of this SceneNode.

This method allows a list of lights, ordered by proximity to the centre of this SceneNode, to be retrieved. Can be useful when implementing MovableObject::queryLights and Renderable::getLights.

  Note that only lights could be affecting the frustum will take into account, which cached in scene manager.

See also
  SceneManager::_getLightsAffectingFrustum
  SceneManager::_populateLightList

Parameters

  destList | List to be populated with ordered set of lights; will be cleared by this method before population.
  radius | Parameter to specify lights intersecting a given radius of this SceneNode's centre.
  lightMask | The mask with which to include / exclude lights

## ◆ setFixedYawAxis()

void Ogre::SceneNode::setFixedYawAxis | ( | bool | useFixed,
|  | const Vector3 & | fixedAxis = Vector3::UNIT_Y )

Tells the node whether to yaw around it's own local Y axis or a fixed axis of choice.

This method allows you to change the yaw behaviour of the node - by default, it yaws around it's own local Y axis when told to yaw with TS_LOCAL, this makes it yaw around a fixed axis. You only really need this when you're using auto tracking (see setAutoTracking, because when you're manually rotating a node you can specify the TransformSpace in which you wish to work anyway.

Parameters

  useFixed | If true, the axis passed in the second parameter will always be the yaw axis no matter what the node orientation. If false, the node returns to it's default behaviour.
  fixedAxis | The axis to use if the first parameter is true.

## ◆ yaw()

void Ogre::SceneNode::yaw | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = TS_LOCAL )
| overridevirtual

Rotate the node around the Y-axis.

Reimplemented from Ogre::Node.

References Ogre::Node::TS_LOCAL.

## ◆ setDirection() [1/2]

void Ogre::SceneNode::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = TS_PARENT,
|  | const Vector3 & | localDirectionVector = Vector3::NEGATIVE_UNIT_Z )

Sets the node's direction vector ie it's local -z.

Note that the 'up' vector for the orientation will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same). If you need more control, use setOrientation.

Parameters

  x,y,z | The components of the direction vector
  relativeTo | The space in which this direction vector is expressed
  localDirectionVector | The vector which normally describes the natural direction of the node, usually -Z

References Ogre::Node::TS_PARENT.

## ◆ setDirection() [2/2]

void Ogre::SceneNode::setDirection | ( | const Vector3 & | vec,
|  | TransformSpace | relativeTo = TS_PARENT,
|  | const Vector3 & | localDirectionVector = Vector3::NEGATIVE_UNIT_Z )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::Node::TS_PARENT.

## ◆ lookAt()

void Ogre::SceneNode::lookAt | ( | const Vector3 & | targetPoint,
|  | TransformSpace | relativeTo,
|  | const Vector3 & | localDirectionVector = Vector3::NEGATIVE_UNIT_Z )

Points the local -Z direction of this node at a point in space.

Parameters

  targetPoint | A vector specifying the look at point.
  relativeTo | The space in which the point resides
  localDirectionVector | The vector which normally describes the natural direction of the node, usually -Z

## ◆ setAutoTracking()

void Ogre::SceneNode::setAutoTracking | ( | bool | enabled,
|  | SceneNode *const | target = 0,
|  | const Vector3 & | localDirectionVector = Vector3::NEGATIVE_UNIT_Z,
|  | const Vector3 & | offset = Vector3::ZERO )

Enables / disables automatic tracking of another SceneNode.

If you enable auto-tracking, this SceneNode will automatically rotate to point it's -Z at the target SceneNode every frame, no matter how it or the other SceneNode move. Note that by default the -Z points at the origin of the target SceneNode, if you want to tweak this, provide a vector in the 'offset' parameter and the target point will be adjusted.

Parameters

  enabled | If true, tracking will be enabled and the next parameter cannot be null. If false tracking will be disabled and the current orientation will be maintained.
  target | Pointer to the SceneNode to track. Make sure you don't delete this SceneNode before turning off tracking (e.g. SceneManager::clearScene will delete it so be careful of this). Can be null if and only if the enabled param is false.
  localDirectionVector | The local vector considered to be the usual 'direction' of the node; normally the local -Z but can be another direction.
  offset | If supplied, this is the target point in local space of the target node instead of the origin of the target node. Good for fine tuning the look at point.

References SceneNode().

## ◆ getAutoTrackTarget()

SceneNode * Ogre::SceneNode::getAutoTrackTarget | ( | void |  | ) | const
| inline

Get the auto tracking target for this node, if any.

References SceneNode().

## ◆ getAutoTrackOffset()

const Vector3 & Ogre::SceneNode::getAutoTrackOffset | ( | void |  | ) | const
| inline

Get the auto tracking offset for this node, if the node is auto tracking.

## ◆ getAutoTrackLocalDirection()

const Vector3 & Ogre::SceneNode::getAutoTrackLocalDirection | ( | void |  | ) | const
| inline

Get the auto tracking local direction for this node, if it is auto tracking.

## ◆ _autoTrack()

void Ogre::SceneNode::_autoTrack | ( | void |  | ) |

Internal method used by OGRE to update auto-tracking cameras.

## ◆ getParentSceneNode()

SceneNode * Ogre::SceneNode::getParentSceneNode | ( | void |  | ) | const

Gets the parent of this SceneNode.

References SceneNode().

## ◆ setVisible()

void Ogre::SceneNode::setVisible | ( | bool | visible,
|  | bool | cascade = true ) const

Makes all objects attached to this node become visible / invisible.

This is a shortcut to calling setVisible() on the objects attached to this node, and optionally to all objects attached to child nodes.

Parameters

  visible | Whether the objects are to be made visible or invisible
  cascade | If true, this setting cascades into child nodes too.

## ◆ flipVisibility()

void Ogre::SceneNode::flipVisibility | ( | bool | cascade = true | ) | const

Inverts the visibility of all objects attached to this node.

This is a shortcut to calling setVisible(!isVisible()) on the objects attached to this node, and optionally to all objects attached to child nodes.

Parameters

  cascade | If true, this setting cascades into child nodes too.

## ◆ setDebugDisplayEnabled()

void Ogre::SceneNode::setDebugDisplayEnabled | ( | bool | enabled,
|  | bool | cascade = true ) const

Tells all objects attached to this node whether to display their debug information or not.

This is a shortcut to calling setDebugDisplayEnabled() on the objects attached to this node, and optionally to all objects attached to child nodes.

Parameters

  enabled | Whether the objects are to display debug info or not
  cascade | If true, this setting cascades into child nodes too.

The documentation for this class was generated from the following file:

- OgreSceneNode.h